
#ifndef CTWXDEF
#define CTWXDEF

#include "QCWIN.H"
#include "QCWRT.H"

#define ST_LINEPLOT 0
#define ST_BARGRAPH 1
#define ST_SCATTERPLOT 2

#define X_AXIS1 0
#define Y_AXIS1 1
#define X_AXIS2 2
#define Y_AXIS2 3

#define AXES1 0
#define AXES2 1

#define TITLE1 0
#define TITLE2 1
#define FOOTER 2 

#define NUMAXES 4
#define NUMTITLES 3


#define MAX_WCTX_TRACES 32
#define MAX_WCTX_GROUPS 16
#define MAX_WCTX_DATAPOINTS 1000000
#define MAX_WCTX_AXISSTRINGS 32
#define MAX_WCTX_DATACURSORS 32
#define MAX_RTMETERX_NEEDLES 5
#define MAX_RTBARX_BARS 32
#define MAX_RTANNUNX_CELLS 32
#define MAX_RTPIDX_BARS 3
#define MAX_RTDATASETS 4
#define MAX_RTCHANNELS 32


#define MAX_WCTX_DEMO_TRACES     4
#define MAX_WCTX_DEMO_DATAPOINTS  10
#define MAX_WCTX_DEMO_GROUPS  4

#define MINLOGSCALEVALUE 1.0e-20

#define SIMPLE_XY_DATA_TYPE 0
#define GROUP_DATA_TYPE     1
#define PIECHART_DATA_TYPE  2 


#define SCROLLING_LINE_GRAPH         0
#define SWEEP_GRAPH                  1
#define SCROLLING_BAR_GRAPH          2
#define SCROLLING_STACKED_LINE_GRAPH 3
#define SCROLLING_XY_GRAPH           4
#define VARIABLE_SCROLLING_GRAPH     5


#define SIMPLE_LEGEND 0
#define GROUP_LEGEND  1

#define LEGEND_BLACKTEXT 0
#define LEGEND_COLORTEXT 1

#define RTMETER_NEEDLE 0
#define RTMETER_ARC 1
#define RTMETER_PIE 2


#define PRT_POSITIONONPAGE PRT_EXACT + 1

#define WCTX_MIN_SIZE 50

#define WRTX_MIN_CONTROL_SIZE 25


#define CROSSHAIR_NONE 0
#define CROSSHAIR_GRAPHAREA 1
#define CROSSHAIR_PLOTAREA 2
#define CROSSHAIR_SMALL 3

#define DATACURSOR_DISABLED 0
#define DATACURSOR_LEFTBUTTON 1
#define DATACURSOR_RIGHTBUTTON 2

#define GRIDLINE_UPDATE_TIMER 0
#define GRIDLINE_UPDATE_EVERY 1
#define GRIDLINE_UPDATE_NEVER 2

#define ALARMLINE_UPDATE_TIMER 0
#define ALARMLINE_UPDATE_EVERY 1
#define ALARMLINE_UPDATE_NEVER 2

  

#define RGB_BLACK        0x000000                      
#define RGB_BLUE         0x800000   //RGB (  0,0,128),                       
#define RGB_GREEN        0x008000   //RGB (  0,128,  0),                       
#define RGB_CYAN         0x808000   //RGB (  0,128,128),                        
#define RGB_RED          0x000080   //RGB (128,  0,  0),                         
#define RGB_MAGENTA      0x800080   //RGB (128,  0,128),                     
#define RGB_BROWN        0x008080   //RGB (128,128,  0),                       
#define RGB_LIGHTGRAY    0xc0c0c0   //RGB (192,192,192),                        
#define RGB_GRAY         0x808080   //RGB (128,128,128),                        
#define RGB_LIGHTBLUE    0xff0000   //RGB (  0,  0,255),                   
#define RGB_LIGHTGREEN   0x00ff00   //RGB (  0,255,  0),                  
#define RGB_LIGHTCYAN    0xffff00   //RGB (  0,255,255),                   
#define RGB_LIGHTRED     0x0000ff   //RGB (255,  0,  0),                    
#define RGB_LIGHTMAGENTA 0xff00ff   //RGB (255,  0,255),                
#define RGB_YELLOW       0x00ffff   //RGB (255,255,  0),                      
#define RGB_WHITE        0xffffff   //RGB (255,255,255),              
               // for SVGA in 256 colors mode
#define RGB_PALEBLUE     0xf0caa6   //RGB (166,202,240),              
#define RGB_PALEGREEN    0xc0dcc0   //RGB (192,220,192),              
#define RGB_MEDGRAY      0a4xa0a0   //RGB (160,160,164),              
#define RGB_OFFWHITE     0xf6f6ff   //RGB (255,251,240),              

#endif